import { History } from 'history';
import { History as ReachHistory } from '@reach/router';
import { Middleware, Reducer, Store } from 'redux';
import { RouterState } from './reducer';
export interface IHistoryContextOptions {
    history: History;
    routerReducerKey?: string;
    oldLocationChangePayload?: boolean;
    reduxTravelling?: boolean;
    showHistoryAction?: boolean;
    selectRouterState?: <S>(state: S) => RouterState;
    savePreviousLocations?: number;
    batch?: (callback: () => void) => void;
    reachGlobalHistory?: ReachHistory;
}
export interface IHistoryContext {
    createReduxHistory: (store: Store) => History & {
        listenObject: boolean;
    };
    routerMiddleware: Middleware;
    routerReducer: Reducer;
}
export declare const createReduxHistoryContext: ({ history, routerReducerKey, reduxTravelling, showHistoryAction, selectRouterState, savePreviousLocations, batch, reachGlobalHistory, }: IHistoryContextOptions) => IHistoryContext;
